#include <iostream>
using namespace std;

int main () {
	srand48(time(nullptr));
	int rows, columns;
	cout << "Number of rows: ";
	cin >> rows;
	int **array_2d = new int*[rows]; // allocate vector of rows' addresses
	int *lengths = new int[rows]; // lengths of rows

	for (int i = 0; i < rows; i++) {
		columns = (int)(lrand48() % 10) + 2;
		cout << "length of " << i << "-th row is " << columns << endl;
		lengths[i] = columns;
		array_2d[i] = new int[columns]; // allocate i-th row
		for (int j = 0; j < columns; j++) {
			array_2d[i][j] = (int)(lrand48() % 100);
		}
	}
	cout << endl;

	for (int i = 0; i < rows; i++) {
		cout << "row " << i << ": [ ";
		for (int j = 0; j < lengths[i]; j++)
			cout << array_2d[i][j] << " ";
		cout << "]" << endl;
	}
	cout << endl;

	// free memory
	for (int i = 0; i < rows; i++) delete[] array_2d[i];
	delete[] array_2d;
	delete[] lengths;

	return EXIT_SUCCESS;
}

