#include <iostream>
using namespace std;

const int dim{5};

void print1(int *t, int n) {
	cout << "print1(int *t)" << endl;
	cout << "sizeof(t) = " << sizeof(t) << endl;
	for (int i = 0; i < n; i++) cout << t[i] << " ";
	cout << endl;
	cout << endl;
}

void print2(int t[dim], int n) {
	cout << "print2(int t[dim])" << endl;
	cout << "sizeof(t) = " << sizeof(t) << endl;
	for (int i = 0; i < n; i++) cout << t[i] << " ";
	cout << endl;
	cout << endl;
}

int main() {
	int array[dim];
	srand48(time(nullptr));

	cout << "sizeof(array) = " << sizeof(array) << endl;
	cout << "sizeof(array) / sizeof(int) = " << sizeof(array) / sizeof(int) << endl;
	cout << endl;

	for (int &value : array) value = (int)(lrand48() % 100);
	print1(array, dim);
	print2(array, dim);

	return EXIT_SUCCESS;
}

