#include <iostream>
using namespace std;

void swap_wrong(int, int);
void swap_ptr(int*, int*);
void swap_ref(int&, int&);

int main() {
	int i = 5, j = 8;
	int *pi = &i, *pj = &j;

	cout << "i = " << i << endl;
	cout << "j = " << j << endl;
	cout << endl;

	swap_wrong (i, j);
	cout << "After swap_wrong()\n";
	cout << "i = " << i << endl;
	cout << "j = " << j << endl;
	cout << endl;

	swap_ptr (pi, pj);
	cout << "After swap_ptr()\n";
	cout << "i = " << i << endl;
	cout << "j = " << j << endl;
	cout << endl;
	
	swap_ptr (&i, &j);
	cout << "After another swap_ptr()\n";
	cout << "i = " << i << endl;
	cout << "j = " << j << endl;
	cout << endl;
	
	swap_ref (i, j);
	cout << "After swap_ref()\n";
	cout << "i = " << i << endl;
	cout << "j = " << j << endl;

	return EXIT_SUCCESS;
}	

void swap_wrong (int i, int j) {
	int temp = i;
	i = j;
	j = temp;
}

void swap_ref (int &i, int &j) {
	int temp = i;
	i = j;
	j = temp;
}

void swap_ptr (int *i, int *j) {
	int temp = *i;
	*i = *j;
	*j = temp;
}

