#include <iostream>
#include <cstring>
using namespace std;

void print(char**);
void free_memory(char**);

int main() {
	constexpr int max_line_length{256};
	constexpr int max_lines{256};
	char str[max_line_length];
	char *lines[max_lines]{};
	int n = 0;
	while(n < max_lines && cin.getline(str, max_line_length)) {
		lines[n++] = strdup(str);
	}
	print(lines);
	free_memory(lines);

	return EXIT_SUCCESS;
}

void print(char *lines[]) {
	while(*lines) cout << *lines++ << endl;
}

void free_memory(char *lines[]) {
	while(*lines) free(*lines++);
}

