#include <iostream>
using namespace std;

int main() {
	auto* p_int{new int};	//	allocate space for an int
	*p_int = 1;	//	store a value there
	cout << "int value = " << *p_int << ": location = " << p_int << endl;
	cout << "size of p_int = " << sizeof(p_int);
	cout << ": size of *p_int = " << sizeof(*p_int) << endl;
	delete p_int;
	cout << endl;

	auto* p_double{new double};	//	allocate space for a double
	*p_double = 2.5;	//	store a double there
	cout << "double value = " << *p_double << ": location = " << p_double << endl;
	cout << "size of p_double = " << sizeof(p_double);
	cout << ": size of *p_double = " << sizeof(*p_double) << endl;
	delete p_double;

	return EXIT_SUCCESS;
}

